/* Fares Belhadj 20/05/2005 */
/* amsi@ai.univ-paris8.fr   */
#define inf 4000
#define WIDTH  400
#define HEIGHT 400
#define GAUCHE -inf
#define DROITE  inf
#define HAUT    inf
#define BAS    -inf
#define IsInTheCircle(p, c) ((p.x - c.c.x) * (p.x - c.c.x) + \
			     (p.y - c.c.y) * (p.y - c.c.y) - c.r * c.r < 0)
#define IsSameSegment(s1, s2) ( (((s1).p1.x == (s2).p1.x) && ((s1).p1.y == (s2).p1.y) && \
				 ((s1).p2.x == (s2).p2.x) && ((s1).p2.y == (s2).p2.y)) || \
				(((s1).p1.x == (s2).p2.x) && ((s1).p1.y == (s2).p2.y) && \
				 ((s1).p2.x == (s2).p1.x) && ((s1).p2.y == (s2).p1.y))   )
#define IsOnCorner(p) ( ((p).x == GAUCHE && (p).y == HAUT) || \
			((p).x == GAUCHE && (p).y == BAS)  || \
			((p).x == DROITE && (p).y == HAUT) || \
			((p).x == DROITE && (p).y == BAS) )
#define Scalar(p1, p2) ((p1.x * p2.x) + (p1.y * p2.y))

typedef struct Point2D Point2D;
typedef struct Cercle Cercle;
typedef struct Triangle Triangle;
typedef struct TriangleList TriangleList;
typedef struct Segment Segment;
typedef struct SegmentList SegmentList;

struct Point2D {
  double x, y;
};
struct Cercle {
  Point2D c;
  double r;
};
struct Triangle {
  Point2D p1, p2, p3;
  Cercle * C;
};
struct Segment {
  Point2D p1, p2;
};
struct TriangleList {
  Triangle T;
  struct TriangleList * next;
};
struct SegmentList {
  Segment S;
  struct SegmentList * next;
};
/* from ps.c */
extern void          psBeginDocument(void);
extern void          psEndDocument(void);
extern void          psPrintSegments(SegmentList * sl);
/* from delaunay.c */
extern SegmentList * generateDelaunay(int nbPoints);
extern void          freeSegments(SegmentList * sl);
